#-----------------------------------------------------------------------------
# Me-camera
# Copyright (c) 2007 David G. Drumright (ockham)
# 3/20/07
# As suggested by Sguthery in rendo forum....
#-----------------------------------------------------------------------------

from Tkinter import *
import poser
import math
scene = poser.Scene()

UArrow = '\x26'
DArrow = '\x28'
LArrow = '\x25'
RArrow = '\x27'

Dolly = scene.Actor("Dolly Camera")
Dolly = scene.SetCurrentCamera(Dolly)
FBParm = scene.CurrentCamera().ParameterByCode(poser.kParmCodeZTRAN)
LRParm = scene.CurrentCamera().ParameterByCode(poser.kParmCodeXTRAN)
TParm  = scene.CurrentCamera().ParameterByCode(poser.kParmCodeYROT)
Step = 0.05
Deg = 5
D2R=math.pi/180.0
# Pos yrot = left turn
# x-coord of move = -sin(yrot)
# z-coord of move = cos(yrot)

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("me cam")
        self.MeBox = Entry(self.master,width=20)
        self.MeBox.grid(row=0,column=0)
        self.MeBox.insert(0,"Click here, use arrows")

        root.bind(sequence='<KeyPress-Down>', func=self.MoveCamB)
        root.bind(sequence='<KeyPress-Up>',   func=self.MoveCamF)
        root.bind(sequence='<KeyPress-Left>', func=self.MoveCamL)
        root.bind(sequence='<KeyPress-Right>',func=self.MoveCamR)
        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene:
            scene.ProcessSomeEvents()
            scene.DrawAll()
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -
    def MoveCamB(self,event):
        Yr=TParm.Value()*D2R
        Zc=Step*math.cos(Yr)
        Xc=-Step*math.sin(Yr)
        FBParm.SetValue(FBParm.Value()+Zc)
        LRParm.SetValue(LRParm.Value()+Xc)
    #-----------------------------------------------------------------------------
    def MoveCamF(self,event):
        Yr=TParm.Value()*D2R
        Zc=Step*math.cos(Yr)
        Xc=-Step*math.sin(Yr)
        FBParm.SetValue(FBParm.Value()-Zc)
        LRParm.SetValue(LRParm.Value()+Xc)
    #-----------------------------------------------------------------------------
    def MoveCamR(self,event):
        TParm.SetValue(TParm.Value()-Deg)
        Yr=TParm.Value()*D2R
        Zc=Step*math.cos(Yr)
        Xc=-Step*math.sin(Yr)
        FBParm.SetValue(FBParm.Value()-Zc)
        LRParm.SetValue(LRParm.Value()+Xc)
    #-----------------------------------------------------------------------------
    def MoveCamL(self,event):
        TParm.SetValue(TParm.Value()+Deg)
        Yr=TParm.Value()*D2R
        Zc=Step*math.cos(Yr)
        Xc=-Step*math.sin(Yr)
        FBParm.SetValue(FBParm.Value()-Zc)
        LRParm.SetValue(LRParm.Value()+Xc)
    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
